---
schema_version: "1"
id: 74666c1333337e382f02ea8011623866c0c2462f04ff174dc06914a48eda8ea4
title: UI API Limitations
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/service-cloud/knowledge/guides/knowledge-development-uiapi-limitations.md
canonical_url: https://developer.salesforce.com/docs/service/salesforce-knowledge-dev-guide/guide/knowledge-development-uiapi-limitations.html
source_site: developer.salesforce.com
content_type: documentation
content_hash: 838c1b4e66cf1cdc4227a316fe061754c7653838cb01df4397f4c2575b55e04b
products:
  - Salesforce Knowledge Developer Guide
  - Service Cloud Developer Content
---

# UI API Limitations

UI API with Lightning Knowledge has these limitations.

## RecordTypeId of Linked Record Shows as Null When It Shouldn’t

To retrieve the `recordTypeId` of a `LinkedArticle.LinkedEntity` record using the [Get a Record](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_record_get.htm) UI API, replace `Id` with `RecordTypeId`. This limitation applies to API version 57.0 and later.

```nolang
// This code doesn't retrieve the correct recordTypeId.
GET /services/data/v57.0/ui-api/records/{LinkedArticleId}?fields=LinkedArticle.LinkedEntity.Id
// This code retrieves the correct recordTypeId.
GET /services/data/v57.0/ui-api/records/{LinkedArticleId}?fields=LinkedArticle.LinkedEntity.RecordTypeId
```

The response shows the record type ID in two places.

- `LinkedEntity` | `value` | `fields` | `RecordTypeId` | `value`—Shows the correct record type ID.
- `LinkedEntity` | `value` | `recordTypeId`—Shows null even if there’s an associated record type.

```nolang
{
    "apiName": "LinkedArticle",
    "childRelationships": {},
    "eTag": "0a4b81f3e165e7feefcc2f0e0f30e6da",
    "fields": {
        "LinkedEntity": {
            "displayValue": "00000001",
            "value": {
                "apiName": "Name",
                "childRelationships": {},
                "eTag": "0917224c30df4322d4e5abbda36a9c25",
                "fields": {
                    "Id": {
                        "displayValue": null,
                        "value": "0WORM0000006nan4AA"
                    },
                    "RecordTypeId": {
                        "displayValue": null,
                        "value": "012RM0000005Yl2YAE"
                    }
                },
                "id": "0WORM0000006nan4AA",
                "lastModifiedById": null,
                "lastModifiedDate": null,
                "recordTypeId": null,
                "recordTypeInfo": null,
                "systemModstamp": null,
                "weakEtag": 0
            }
        },
        "LinkedEntityId": {
            "displayValue": null,
            "value": "0WORM0000006nan4AA"
        }
    },
    "id": "1WKRM0000004MKA4A2",
    "lastModifiedById": "005RM000002Z4dkYAC",
    "lastModifiedDate": "2022-09-28T18:12:10.000Z",
    "recordTypeId": "012000000000000AAA",
    "recordTypeInfo": null,
    "systemModstamp": "2022-09-28T18:12:10.000Z",
    "weakEtag": 1664388730000
}
```

## object-info UI API Returns an Error

Changing the **Object Name** of the Knowledge object in **Object Manager** results in an error when you run the [Get Object Metadata](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_object_info.htm) UI API for `LinkedArticle` or `CaseArticle`. Don’t change the Knowledge object name. This limitation applies to API version 57.0 and later.

![Object Manager Details tab that shows Knowledge object name that must not change.](https://developer.salesforce.com/docs/media/knowledge/knowledge_object_name.png '{"class": "image-lg"}')

For example, you change the Knowledge object name and run these UI APIs.

```nolang
GET /services/data/v57.0/ui-api/object-info/LinkedArticle
GET /services/data/v57.0/ui-api/object-info/CaseArticle
```

You get an `INSUFFICIENT_ACCESS` error.

```nolang
{
    "errorCode":"INSUFFICIENT_ACCESS",
    "message":"You don't have access to this record. Ask your administrator for help or to request access."
}
```

## Retrieving KnowledgeArticleVersion.RecordTypeId Fails

To retrieve the `KnowledgeArticleVersion.RecordTypeId` of `LinkedArticle` or `CaseArticle` records using the [Get a Record](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_record_get.htm) UI API, use the `optionaFields` not `fields` request parameter. This limitation applies to API version 57.0 and later.

```nolang
GET /services/data/v57.0/ui-api/records/{LinkedArticleId}?optionalFields=LinkedArticle.KnowledgeArticleVersion.RecordTypeId
GET /services/data/v57.0/ui-api/records/{CaseArticleId}?optionalFields=CaseArticle.KnowledgeArticleVersion.RecordTypeId
```

Here’s the error that you get when you try to retrieve this `RecordTypeId` using the `fields` request parameter.

```nolang
{
    "errorCode": "INVALID_FIELD",
    "message": "INVALID_FIELD: \nSELECT LastModifiedDate, KnowledgeArticleVersion.RecordTypeId\n                         ^\nERROR at Row:1:Column:26\nNo such column 'RecordTypeId' on entity 'KnowledgeArticleVersion'. If you are attempting to use a custom field, be sure to append the '__c' after the custom field name. Please reference your WSDL or the describe call for the appropriate names."
}
```

## Record Data and Metadata of Related Lists Don’t Show Up

If the related object isn’t added to the page layout of the parent record, UI API doesn’t return the record data or metadata of related lists. This limitation applies to API version 57.0 and later.

The affected endpoints are:

- [Get Related List Records with URL Parameters](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_list_records.htm)
- [Get Related List Records with a Request Body](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_list_records_get.htm)
- [Get Related List Metadata](https://developer.salesforce.com/docs/atlas.en-us.uiapi.meta/uiapi/ui_api_resources_related_list_info_md.htm)

If the related object is missing from the page layout, you encounter one of these problems.

- `NVALID_TYPE` error code
- `UNKNOWN_EXCEPTION` error code
- UI API returns the wrong record, for example, the LinkedArticle record instead of Article

To retrieve the correct record data or metadata with the related list UI API endpoints, add the related object to the parent object’s page layout.

```nolang
/ui-api/related-list-records/{parentRecordId}/{relatedListId}
/ui-api/related-list-info/{parentObjectApiName}/{relatedListId}
```

To add a related list object, go to **Object Manager** | **{PARENT_OBJECT}** | **Page Layouts** | **Related Lists**.

![Page Layouts tab in the Object Manager where you configure the related lists](https://developer.salesforce.com/docs/media/knowledge/configure_object_related_lists.png '{"class": "image-lg"}')

For example, to retrieve the `Articles` related list with these UI API calls, add the **Articles** related list to the **WorkOrder**, **WorkOrderLineItem**, and**Case** page layouts. Apply this solution to other parent object types that **Articles** relate to.

```nolang
GET /services/data/v57.0/ui-api/related-list-records/{WorkOrderId}/LinkedArticles
GET /services/data/v57.0/ui-api/related-list-records/{WorkOrderLineItemId}/LinkedArticles

GET /services/data/v57.0/ui-api/related-list-info/{WorkOrderId}/LinkedArticles
GET /services/data/v57.0/ui-api/related-list-info/{WorkOrderLineItemId}/LinkedArticles
GET /services/data/v57.0/ui-api/related-list-info/{CaseId}/CaseArticles
```

To retrieve related list records related to Knowledge articles with these UI API calls, add the **WorkOrder**, **WorkOrderLineItem**, and**SocialPosts** related objects to the **Knowledge** page layout.

```nolang
GET /services/data/v57.0/ui-api/related-list-records/{KnowledgeArticleVersionId}/LinkedWorkOrders
GET /services/data/v57.0/ui-api/related-list-records/{KnowledgeArticleVersionId}/LinkedWorkOrderLineItems
GET /services/data/v57.0/ui-api/related-list-records/{KnowledgeArticleVersionId}/LinkedSocialPosts

GET /services/data/v57.0/ui-api/related-list-info/{KnowledgeArticleVersionId}/LinkedWorkOrders
GET /services/data/v57.0/ui-api/related-list-info/{KnowledgeArticleVersionId}/LinkedWorkOrderLineItems
GET /services/data/v57.0/ui-api/related-list-info/{KnowledgeArticleVersionId}/LinkedSocialPosts
```

To retrieve record data or metadata of cases related to Knowledge articles, add the **Cases** related list to the **Knowledge** page layout.

```nolang
GET /services/data/v57.0/ui-api/related-list-info/{Knowledge__kavId}/CaseArticles
```
